package org.jboss.security.plugins;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import java.util.Stack;
import javax.management.JMException;
import javax.management.MBeanServer;
import javax.management.MalformedObjectNameException;
import javax.management.ObjectName;
import javax.security.auth.login.Configuration;
import org.jboss.security.plugins.SecurityConfigMBean;
import org.jboss.system.ServiceMBeanSupport;

public class SecurityConfig extends ServiceMBeanSupport implements SecurityConfigMBean {
  private String loginConfigName;
  
  private Stack loginConfigStack = new Stack();
  
  public String getName() {
    return "SecurityIntialization";
  }
  
  public String getLoginConfig() {
    return this.loginConfigName;
  }
  
  public void setLoginConfig(String name) throws MalformedObjectNameException {
    this.loginConfigName = name;
  }
  
  public void startService() throws Exception {
    pushLoginConfig(this.loginConfigName);
  }
  
  public void stopService() throws Exception {
    if (!this.loginConfigStack.empty())
      popLoginConfig(); 
  }
  
  public synchronized void pushLoginConfig(String objectName) throws JMException, MalformedObjectNameException {
    ObjectName name = new ObjectName(objectName);
    Configuration prevConfig = null;
    if (!this.loginConfigStack.empty()) {
      ConfigInfo prevInfo = this.loginConfigStack.peek();
      prevConfig = prevInfo.config;
    } 
    ConfigInfo info = installConfig(name, prevConfig);
    this.loginConfigStack.push(info);
  }
  
  public synchronized void popLoginConfig() throws JMException {
    ConfigInfo info = this.loginConfigStack.pop();
    Configuration prevConfig = null;
    if (!this.loginConfigStack.empty()) {
      ConfigInfo prevInfo = this.loginConfigStack.peek();
      prevConfig = prevInfo.config;
    } 
    installConfig(info.name, prevConfig);
  }
  
  private ConfigInfo installConfig(ObjectName name, Configuration prevConfig) throws JMException {
    MBeanServer server = getServer();
    Object[] args = { prevConfig };
    String[] signature = { "javax.security.auth.login.Configuration" };
    Configuration config = (Configuration)server.invoke(name, "getConfiguration", args, signature);
    Configuration.setConfiguration(config);
    ConfigInfo info = new ConfigInfo(name, config);
    this.log.debug("Installed JAAS Configuration service=" + name + ", config=" + config);
    return info;
  }
}
